package com.ints.bieshop.domain;

import static org.assertj.core.api.Assertions.assertThat;

public class ProductImageAsserts {

    /**
     * Asserts that the entity has all properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertProductImageAllPropertiesEquals(ProductImage expected, ProductImage actual) {
        assertProductImageAutoGeneratedPropertiesEquals(expected, actual);
        assertProductImageAllUpdatablePropertiesEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all updatable properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertProductImageAllUpdatablePropertiesEquals(ProductImage expected, ProductImage actual) {
        assertProductImageUpdatableFieldsEquals(expected, actual);
        assertProductImageUpdatableRelationshipsEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all the auto generated properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertProductImageAutoGeneratedPropertiesEquals(ProductImage expected, ProductImage actual) {
        assertThat(expected)
            .as("Verify ProductImage auto generated properties")
            .satisfies(e -> assertThat(e.getId()).as("check id").isEqualTo(actual.getId()));
    }

    /**
     * Asserts that the entity has all the updatable fields set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertProductImageUpdatableFieldsEquals(ProductImage expected, ProductImage actual) {
        assertThat(expected)
            .as("Verify ProductImage relevant properties")
            .satisfies(e -> assertThat(e.getImage()).as("check image").isEqualTo(actual.getImage()))
            .satisfies(e -> assertThat(e.getIsDeleted()).as("check isDeleted").isEqualTo(actual.getIsDeleted()));
    }

    /**
     * Asserts that the entity has all the updatable relationships set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertProductImageUpdatableRelationshipsEquals(ProductImage expected, ProductImage actual) {
        assertThat(expected)
            .as("Verify ProductImage relationships")
            .satisfies(e -> assertThat(e.getProduct()).as("check product").isEqualTo(actual.getProduct()));
    }
}
